; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\dialogs.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD 
      swtest  PROTO :DWORD

; 
; Macros for storing and retrieving text macros, based on
; the $casstk code from Greg Falen's Switch/Case macros.
; 

    $text_stack$ equ <#>

    pushtext MACRO name:req
        $text_stack$ CATSTR <name>, <#>, $text_stack$
    ENDM

    poptext MACRO name:req
        LOCAL pos
        pos INSTR $text_stack$, <#>
        name SUBSTR $text_stack$, 1, pos-1
        $text_stack$ SUBSTR $text_stack$, pos+1
    ENDM

; 
; Macros to implement a string-comparison specific
; Switch/Case construct. Multiple instances and
; nesting supported.
; 

    $test_val$ equ <>
    $end_sw$ equ <>
    $sw_state$ equ <>
    _sw_cnt_ = 0

    switch$ MACRO lpstring:REQ

        ;; Preserve globals for previous Switch/Case.
        pushtext $test_val$
        pushtext $sw_state$
        pushtext $end_sw$

        ;; Copy string address for this Select/Case
        ;; to global so case$ can access it.
        $test_val$ equ <lpstring>
               
        ;; Set state global to starting value.
        $sw_state$ equ <>

        ;; Generate a unique exit label for this
        ;; Select/Case and preserve it.
        _sw_cnt_ = _sw_cnt_ + 1
        $end_sw$ CATSTR <end_sw>, %_sw_cnt_
        pushtext $end_sw$
    ENDM

    case$ MACRO quoted_text:REQ
        ;; The case statements will be any statements
        ;; between the case$ and the following case$,
        ;; else$, or endsw$.
        ;;
        ;; If this is a following case$, emit a jump
        ;; to the exit label for this Select/Case and
        ;; terminate the .IF block.       
        IFIDN $sw_state$, <if>

          ;; Because there could have been an intervening
          ;; Switch/Case we need to recover the correct
          ;; exit label for this Switch/Case.
          poptext $end_sw$
          pushtext $end_sw$

          jmp   $end_sw$

          .ENDIF
        ENDIF

        ; Start a new .IF block and update the state global.
        .IF FUNC(szCmp, $test_val$, chr$(quoted_text)) != 0
        $sw_state$ equ <if>
    ENDM

    else$ MACRO

        ;; ==========================
          poptext $end_sw$
          pushtext $end_sw$

          jmp   $end_sw$
        ;; ==========================


        ;; If following a case$, terminate the .IF block.
        ;; The state global must be updated to stop the
        ;; endsw$ from terminatinmg the .IF block.
        IFIDN $sw_state$, <if>
          .ENDIF
          $sw_state$ equ <>
        ENDIF
    ENDM

    endsw$ MACRO
        ; If following a case$, terminate the .IF block.
        IFIDN $sw_state$, <if>
          .ENDIF
        ENDIF

        ;; Remove the exit label from the stack.
        poptext $end_sw$

      $end_sw$:

        ;; Recover gobals for previous Switch/Case.
        poptext $end_sw$
        poptext $sw_state$
        poptext $test_val$
    ENDM



    ; -----------------------------
    ; macros for displaying results
    ; -----------------------------
      SBtext MACRO part,lpString
        invoke SendMessage,hStatus,SB_SETTEXT,part-1,reparg(lpString)
      ENDM

      TBtext MACRO lpString
        invoke SetWindowText,FUNC(GetActiveWindow),reparg(lpString)
      ENDM

      EDtext MACRO lpString
        invoke SetWindowText,hEdit,reparg(lpString)
      ENDM

      EDclear equ <EDtext 0>

    .data?
        hWnd      dd ?
        hInstance dd ?
        hStatus   dd ?
        hEdit     dd ?

    .code

; 

start: 
    mov hInstance, FUNC(GetModuleHandle,NULL)
    call main
    invoke ExitProcess,eax

; 

main proc

    invoke InitCommonControls

    Dialog "   ", \                         ; caption
           "MS Sans Serif",10, \            ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            9, \                            ; number of controls
            50,50,250,106, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgButton "word1",WS_TABSTOP,5, 5,50,13,101
    DlgButton "word2",WS_TABSTOP,5,20,50,13,102
    DlgButton "word3",WS_TABSTOP,5,35,50,13,103
    DlgButton "word4",WS_TABSTOP,5,50,50,13,104
    DlgButton "default",WS_TABSTOP,5,65,50,13,105
    DlgButton "Reset",WS_TABSTOP,60,65,50,13,106
    DlgButton "Close",WS_TABSTOP,192,65,50,13,IDCANCEL
    DlgStatus 110
    DlgEdit WS_TABSTOP or ES_MULTILINE or ES_WANTRETURN or \
            ES_LEFT or WS_BORDER or WS_VSCROLL,60,5,182,58,111

    CallModalDialog hInstance,0,DlgProc,NULL

    ret

main endp

; 

align 4

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 

    LOCAL hDC   :DWORD 
    LOCAL ps    :PAINTSTRUCT 
    LOCAL rct   :RECT 
    LOCAL crct  :RECT 
    LOCAL buffer1[260]:BYTE 
    LOCAL buffer2[260]:BYTE 
    LOCAL buffer3[260]:BYTE 
    LOCAL buffer4[260]:BYTE 

    STRING MainTitle,"switch$ Macro Demo"

    Switch uMsg
      Case WM_INITDIALOG
        m2m hWnd, hWin
        invoke SendMessage,hWnd,WM_SETICON,1,
                           FUNC(LoadIcon,NULL,IDI_ASTERISK)
        invoke SetWindowText,hWnd,ADDR MainTitle

        mov hStatus, FUNC(GetDlgItem,hWnd,110)
        GLOBAL sbarray dd 100,200,300,400,-1
        invoke SendMessage,hStatus,SB_SETPARTS,5,ADDR sbarray

        mov hEdit,   FUNC(GetDlgItem,hWnd,111)
        invoke SendMessage,hEdit,WM_SETFONT,
                           FUNC(GetStockObject,ANSI_FIXED_FONT),TRUE
        mov eax, 1

      Case WM_COMMAND
        Switch wParam
          Case 101
            invoke swtest,chr$("word1")

          Case 102
            invoke swtest,chr$("word2")

          Case 103
            invoke swtest,chr$("word3")

          Case 104
            invoke swtest,chr$("word4")

          Case 105
            invoke swtest,chr$("word5")

          Case 106
            EDclear
            SBtext 1,0
            SBtext 2,0
            SBtext 3,0
            SBtext 4,0
            SBtext 5,0
            TBtext ADDR MainTitle

          Case IDCANCEL
            jmp quit_dialog
        Endsw

      Case WM_PAINT
        mov hDC, FUNC(BeginPaint,hWin,ADDR ps)
        invoke GetClientRect,hWin,ADDR rct
        invoke GetWindowRect,hStatus,ADDR crct
        mov eax, crct.bottom
        sub eax, crct.top
        sub rct.bottom, eax
        invoke DrawEdge,hDC,ADDR rct,EDGE_ETCHED,BF_RECT
        invoke EndPaint,hWin,ADDR ps

      Case WM_CLOSE
        quit_dialog: 
        invoke EndDialog,hWin,0
    Endsw

    xor eax, eax
    ret

DlgProc endp

; 

swtest proc lpstr:DWORD

    switch$ lpstr
      case$ "word1"
        fn MessageBox,hWnd,"word1","Title",MB_OK
      case$ "word2"
        fn MessageBox,hWnd,"word2","Title",MB_OK
      case$ "word3"
        fn MessageBox,hWnd,"word3","Title",MB_OK
      case$ "word4"
        fn MessageBox,hWnd,"word4","Title",MB_OK
      else$
        fn MessageBox,hWnd,"default","Title",MB_OK
    endsw$

    ret

swtest endp

; 

end start
